Mantis Bugtracker          
testlink.org

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0001824TestLinkNew Featurepublic2008-10-29 17:512013-05-20 20:06
Reporterlakshmi86 
Assigned Tofman 
PrioritynormalSeverityfeature requestReproducibilityalways
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version1.7.4 
Fixed in Version1.9.7 (2013 Q2 - bug fixing) 
Summary0001824: Contribution- Solution for Testlink 1.7.4 performance issue on the execution side.
DescriptionTo solve the performance issue, I have already provided the analysis in the forum. I am right now uploading the code. The steps are as follows:

1)Copy the functions linked_to_out,lak_get_subtree,get_required_ids,gettestcases in the uploaded common.php to testlink common.php at the end. These code which has to be copied are enclosed between the lines "Lakshmi code starts" and "Lakshmi code ends".
2)In execSetResults.php, planAddTC.php,tc_exec_assignment.php,testSetRemove.php,testplan.class.php,testcase.class.php wherever new code has been added, it is in between the lines "Lakshmi code starts"..... "Lakshmi code ends". Wherever these two lines are there,the code in between has to be copied at the corresponding locations as in the uploaded files.
3)Other modifications done to the code are written in each file with the comment starting with 'Lakshmi:'. Ex: if a variable name is changed in execSetResults.php, in that place, "Lakshmi: the name 'abc' is changed to 'xyz'" is written.
4)When all such modifications are over, all the test cases on the execution side, i.e., in these links mentioned above, will turn up in 3 sec.
Additional InformationPlease put the link to this information in the forum under the topic 'Testlink1.7\Analysis and solution for the performance issue Testlink1.7'. Thank you so much for all the help. Hope this will be of use to people.
TagsNo tags attached.
Database (MySQL,Postgres,etc)
Browser
PHP Version
TestCaseID
QA Team - Task Workflow StatusREADY FOR TESTING
Attached Fileszip file icon upload.zip [^] (45,781 bytes) 2008-10-29 17:51
docx file icon Document on approach and solution.docx [^] (15,514 bytes) 2008-10-30 12:46

- Relationships

-  Notes
(0004601)
saach (reporter)
2008-11-13 09:49

Thanks a ton Lakshmi. I haven't tried your solution yet, however, it sounds like you just read my mind :)) I was searching for days now to see whether someone tried to endeavor on performance issue fixes. I was using filters, and I put get_subtree in there when I stumbled on this Mantis Ticket.

I would love to give your solution a try and provide feedback as soon as I can.

Thanks--
(0004738)
shevian (reporter)
2008-12-01 14:29

hi,by using your instruction,i met a problem:
I got notices from IE, see following.

Notice: Undefined variable: linked_select in E:\ctweb\Apache\Apache2\htdocs\testlink17\lib\functions\testcase.class.php on line 962

Notice: Undefined variable: linked_Join in E:\ctweb\Apache\Apache2\htdocs\testlink17\lib\functions\testcase.class.php on line 963

or it needs to define these two Value?
(0004739)
lakshmi86 (reporter)
2008-12-01 15:01

Hi shevian, u can try these two things:

1)in testcase.php there is a line which says, if($linked!=null)

try changing that to if(!is_null($linked))

2)In php.ini please change the values as:
                         error_reporting = E_Error | ~E_Notice
                         display_errors=off


and are any of your functionalities not working when these notices appear?
(0004740)
shevian (reporter)
2008-12-01 15:50

Thanks for your info,lakshmi86.
After these modification,it still take me about 1~2 minute to open the Specification UI.
There are about 2300 cases in my testlink.Each time when i load to specification interface,i have to wait about 2minutes.And this also happens when i update testcases.
If the refresh is needed, i have to wait...
I am gonna be crazy.
(0004741)
lakshmi86 (reporter)
2008-12-01 16:48

Hi,
the solution i have given is for the performance issue on the execution side. For specifications, u can probably try changing the tree in config.inc to jtree which is the fastest ($g_tree_type='JTREE') and also try increasing the values of the following parameters in php.ini

max_execution_time =1000 ; Maximum execution time of each script, in seconds
max_input_time = 1000 ; Maximum amount of time each script may spend parsing request data
;max_input_nesting_level = 64 ; Maximum input variable nesting level
memory_limit = 1024M ; Maximum amount of memory a script may consume (128MB)

These suggestions are given by the Testlink people itself
(0004742)
shevian (reporter)
2008-12-01 17:09

TO lakshmi86:
Thanks so much!
You did help me so much.
(0004769)
svanuitert (reporter)
2008-12-05 01:48

Lakshmi86,

In the /lib/functions/common.php, in your function linked_to_out you have a variable $testsuite_ids that is undefined. I have not been able to locate where this is supposed to be declared. Any ideas?

BTW, I love the performance change.
(0005013)
fman (administrator)
2009-01-15 18:07

Best solution is migration to 1.8
(0005580)
gladis (reporter)
2009-02-23 14:33

Hi fman,
Am evaluating TestLink 1.8 RC4.
Here also i have great performance issue. It takes upto 5 minutes to load my test cases for execution.
I have nearly 10000 test cases. i tried implementing the changes as told by Lakshmi, but i could not find some of the functions. Is there any other way?
(0005581)
lakshmi86 (reporter)
2009-02-23 15:09

Hi gladis,

The performance fix i have mentioned here is for Testlink1.7.4. There are currently teams in our company who are using this version with 15000 test cases and are doing fine. The test cases come up in about 3 sec on the execution side. We are also looking at migrating to 1.8 but yet to work on the performance side.
(0005585)
fman (administrator)
2009-02-23 18:13

No more work will be done on 1.7.x => you have to migrate to 1.8
(0005593)
gladis (reporter)
2009-02-23 20:35

I have been using 1.8 only already. Still then i have lot of performance issue.
Is there any other solution?
(0005604)
fman (administrator)
2009-02-24 21:52

@gladis:
1. please send you a dump of your db (zipped) to francisco.mancardi@gmail.com
   (then we can use it for our tests)
2. give detailed steps to reproduce

regards
(0005745)
gladis (reporter)
2009-03-05 14:28
edited on: 2009-03-05 15:18

Hi fman:
1.I ll send you the dump soon. since we have confidential test cases imported am waiting for the approval to send it to you.

2.Steps to reproduce:
1.Import about 10500 test cases under different test suites.
2.Associate them under a test plan.
3.Click on execute in the home page.

The test case execution page opens and it takes upto 2 to 3 mins to load the tree.

(0007063)
mhavlat (reporter)
2009-05-27 21:44

Francisco, did you receive the DB. Could you draft your conclusion if any?
(0007401)
mhavlat (reporter)
2009-06-30 15:08

I see that Andreas left it. I try to look and investigate what should be used in the current version.
Lakshmi, do you have some of these fixes for 1.8 version? Thanks for any answer.
(0007440)
lakshmi86 (reporter)
2009-07-04 14:59

Hi,

I am sorry I was totally held up with work. Currently I have not used this on 1.8 version. But i will try it out this week and reply soon.
(0008170)
aksinghv (reporter)
2009-10-28 23:02

Hi Lakshmi,

Did you give a shot on Test Link 1.8? I am also facing performance issue in TL 1.8.4.

Regards,
Anjani Singh

- Issue History
Date Modified Username Field Change
2008-10-29 17:51 lakshmi86 New Issue
2008-10-29 17:51 lakshmi86 File Added: upload.zip
2008-10-30 00:20 schlundus Status new => assigned
2008-10-30 00:20 schlundus Assigned To => schlundus
2008-10-30 12:46 lakshmi86 File Added: Document on approach and solution.docx
2008-11-13 09:49 saach Note Added: 0004601
2008-12-01 14:29 shevian Note Added: 0004738
2008-12-01 15:01 lakshmi86 Note Added: 0004739
2008-12-01 15:50 shevian Note Added: 0004740
2008-12-01 16:48 lakshmi86 Note Added: 0004741
2008-12-01 17:09 shevian Note Added: 0004742
2008-12-05 01:48 svanuitert Note Added: 0004769
2009-01-15 03:31 schlundus Assigned To schlundus =>
2009-01-15 18:07 fman Note Added: 0005013
2009-02-23 14:33 gladis Note Added: 0005580
2009-02-23 15:09 lakshmi86 Note Added: 0005581
2009-02-23 18:13 fman Note Added: 0005585
2009-02-23 20:35 gladis Note Added: 0005593
2009-02-24 21:52 fman Note Added: 0005604
2009-03-05 14:28 gladis Note Added: 0005745
2009-03-05 15:18 gladis Note Edited: 0005745
2009-05-27 21:44 mhavlat Note Added: 0007063
2009-06-30 15:06 mhavlat Assigned To => mhavlat
2009-06-30 15:08 mhavlat Note Added: 0007401
2009-07-04 14:59 lakshmi86 Note Added: 0007440
2009-10-28 23:02 aksinghv Note Added: 0008170
2010-02-25 00:44 mhavlat Status assigned => acknowledged
2010-02-28 22:22 mhavlat Note Added: 0009228
2010-02-28 22:28 mhavlat Assigned To mhavlat =>
2012-06-04 22:07 fman Note Deleted: 0009228
2013-05-20 20:06 fman QA Team - Task Workflow Status => READY FOR TESTING
2013-05-20 20:06 fman Status acknowledged => closed
2013-05-20 20:06 fman Assigned To => fman
2013-05-20 20:06 fman Resolution open => fixed
2013-05-20 20:06 fman Fixed in Version => 1.9.7 (2013 Q2 - bug fixing)



Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker